from arkindex.project.tests import FixtureTestCase
from arkindex.images.consumers import ImagesConsumer


class TestImagesConsumer(FixtureTestCase):

    @classmethod
    def setUpTestData(cls):
        super().setUpTestData()
        cls.img = cls.imgsrv.images.get(path='img1')

    def test_resize(self):
        polygons_before = sorted(self.img.zones.values_list('polygon', flat=True))

        with self.assertNumQueries(4):
            ImagesConsumer({}).images_resize({'id': str(self.img.id), 'ratio': 0.5})

        polygons_after = sorted(self.img.zones.values_list('polygon', flat=True))

        self.assertListEqual(
            [polygon * 0.5 for polygon in polygons_before],
            polygons_after,
        )

    def test_resize_ratios(self):
        with self.assertRaises(AssertionError, msg='Ratio cannot be negative or zero'):
            ImagesConsumer({}).images_resize({'id': str(self.img.id), 'ratio': 0})

        with self.assertRaises(AssertionError, msg='Ratio cannot be negative or zero'):
            ImagesConsumer({}).images_resize({'id': str(self.img.id), 'ratio': -42})
